import logging
import StringIO

from twisted.trial.unittest import TestCase as TrialTestCase
from ensemble.lib.mocker import MockerTestCase


class TestCase(MockerTestCase, TrialTestCase):
    """
    Base class for all Ensemble tests.
    """

    def capture_logging(self, name="", level=logging.INFO):
        log_file = StringIO.StringIO()
        log_handler = logging.StreamHandler(log_file)
        logger = logging.getLogger(name)
        logger.addHandler(log_handler)
        old_logger_level = logger.level
        logger.setLevel(level)

        @self.addCleanup
        def reset_logging():
            logger.removeHandler(log_handler)
            logger.setLevel(old_logger_level)

        return log_file
