#
import yaml


class ProviderMachine(object):
    """
    Representative of a machine resource created by a C{MachineProvider}. The
    object is typically annotated by the machine provider, such that the
    provider can perform subsequent actions upon it, using the additional
    metadata for identification, without leaking these details to consumers of
    the C{MachineProvider} api.
    """

    def __init__(self, dns_name):
        self.dns_name = dns_name

    def serialize(self):
        return yaml.dump(self.__dict__)
